package com.liang.dao;

import com.liang.entity.BasePerson;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (BasePerson)表数据库访问层
 *
 * @author makejava
 * @since 2023-03-03 15:23:57
 */
public interface BasePersonDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    BasePerson queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param basePerson 查询条件
     * @param pageable   分页对象
     * @return 对象列表
     */
    List<BasePerson> queryAllByLimit(BasePerson basePerson, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param basePerson 查询条件
     * @return 总行数
     */
    long count(BasePerson basePerson);

    /**
     * 新增数据
     *
     * @param basePerson 实例对象
     * @return 影响行数
     */
    int insert(BasePerson basePerson);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<BasePerson> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<BasePerson> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<BasePerson> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<BasePerson> entities);

    /**
     * 修改数据
     *
     * @param basePerson 实例对象
     * @return 影响行数
     */
    int update(BasePerson basePerson);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取列表
     *
     * @return
     */
    List<BasePerson> getBasePersonList(Map map);

    /**
     * 获取项目负责人
     *
     * @return
     */
    List<Map<String, String>> getDKYFZR();

    /**
     * 批量删除
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);

    /**
     * 获取单位人员列表
     *
     * @return
     */
    List<BasePerson> getPersonListByDw(Integer dw, String xm);
}

